function [output_sequence] = arithmetic_decoder(input_sequence, appearance, width)

output_sequence = [];

% sort the table
[table, indices] = sort(appearance,2,'descend');

% make the table cumulative
for it=2:256
    table(it) = table(it)+table(it-1);
end

for i=1:length(input_sequence)
    % read the current symbol
    number = input_sequence(i);

    % restart limits
    lower_limit = 0.0;
    upper_limit = 1.0;
    
    for curr_len = 1:width    
        % find out the absolute location of currently inspected symbol
        for it=1:256
            Upper = table(it)*(upper_limit-lower_limit) + lower_limit;
            Lower = Upper - (appearance(indices(it))*(upper_limit-lower_limit));            
               
            if ((Lower <= number) & (number <= Upper))
                % update the limits
                upper_limit = Upper;
                lower_limit = Lower;
                                      
                %output_sequence = [output_sequence char(indices(it))];
                output_sequence = strcat(output_sequence,{char(indices(it))});
                break;
            end
        end
    end
end



end


